﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using Sailboat.DrawingObjects;
using Sailboat.Generics;
using Sailboat.MovementStrategy;


namespace Sailboat
{
    public partial class FormBoatCollection : Form
    {
        private readonly BoatsGenericCollection<DrawingBoat, DrawingObjectBoat> _boats;
        public FormBoatCollection()
        {
            InitializeComponent();
            _boats = new BoatsGenericCollection<DrawingBoat, DrawingObjectBoat>(pictureBoxCollection.Width, pictureBoxCollection.Height);
        }

        private void buttonAddBoat_Click(object sender, EventArgs e)
        {
            FormSailboat form = new();
            if (form.ShowDialog() == DialogResult.OK)
            {
                if (_boats + form.SelectedBoat != -1)
                {
                    MessageBox.Show("Объект добавлен");
                    pictureBoxCollection.Image = _boats.ShowBoats();
                }
                else
                {
                    MessageBox.Show("Не удалось добавить объект");
                }
            }
        }

        private void buttonRemoveBoat_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Удалить объект?", "Удаление", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
            {
                return;
            }
            int pos = Convert.ToInt32(maskedTextBoxNumber.Text);
            if (_boats - pos != null)
            {
                MessageBox.Show("Объект удален");
                pictureBoxCollection.Image = _boats.ShowBoats();
            }
            else
            {
                MessageBox.Show("Не удалось удалить объект");
            }

        }

        private void buttonRefreshCollection_Click(object sender, EventArgs e)
        {
            pictureBoxCollection.Image = _boats.ShowBoats();
        }
    }
}
